using System;
using System.Collections;
using System.Data.SqlTypes;
using Microsoft.SqlServer.Server;
using AboutTheWeather.com.ejse;

public class Weather
{
	class ZipCache
	{
		SqlInt32 gZipcode;
	}
	[SqlFunctionAttribute (FillRowMethodName="FillRow")]
	public static IEnumerable MakeTheCall (SqlInt32 ZipCode)
	{
		if (ZipCode.IsNull)
		{
			return null;
		}
		else
		{
			ZipCache mycache = new ZipCache(ZipCode);
			Service mycall = new Service();
			NineDayForecastInfo mydata = new NineDayForecastInfo();
			// Get 9 days of weather
			mydata = mycall.GetNineDayForecastInfo((int)ZipCode);
			// Convert the collection to an array to get the free enumerator
			DayForecastInfo[] mydays = new DayForecastInfo[9] 
			{
				mydata.Day1,
				mydata.Day2,
				mydata.Day3,
				mydata.Day4,
				mydata.Day5,
				mydata.Day6,
				mydata.Day7,
				mydata.Day8,
				mydata.Day9
			};
			// And Return it
			return mydays;
		}
	}

	public static void FillRow(Object obj, out SqlString oZipCode,
									       out SqlDateTime oDate,
										   out SqlString oForecast,
										   out SqlInt32 oHigh,
										   out SqlInt32 oLow,
		                                   out SqlInt32 oPrecipitation)
	{
		int DegreePosition = new int();
		int PercentPosition = new int();
		oZipCode=
		// Process day by day
		DayForecastInfo myday = (DayForecastInfo)obj;
		oDate = System.Convert.ToDateTime(myday.Date);
		oForecast = (SqlString)myday.Forecast;
		// Strip the degree character before converting
		DegreePosition = myday.High.IndexOf("");
		oHigh = System.Convert.ToInt32(myday.High.Substring(0,DegreePosition));
		// Strip the degree character before converting
		DegreePosition = myday.Low.IndexOf("");
		oLow = System.Convert.ToInt32(myday.Low.Substring(0, DegreePosition));
		// Strip the percent% character before converting
		PercentPosition = myday.PrecipChance.IndexOf("%");
		oPrecipitation = System.Convert.ToInt32(myday.PrecipChance.Substring(0, PercentPosition));
	}
}

